import bpy.types
import math
from mathutils import Matrix
import mathutils
import functools
import ctypes
from ..utils.pref_utils import get_keyops_prefs
import threading
import time

previuse_gizmo_translate_state = False
current_active_tool = None
        
def reset_pivot(context):
    global current_active_tool
    if current_active_tool:
        bpy.ops.wm.tool_set_by_id(name=current_active_tool)
    context.window_manager.show_3d_gizmo = False
    print("reset pivot")
    
class PivotPress(bpy.types.Operator):
    bl_idname = "keyops.pivot_press"
    bl_label = "KeyOps: Pivot Press"
    bl_description = "Move Pivot Key Press"
    bl_options = {'REGISTER', 'PRESET'}

    type: bpy.props.StringProperty(default="") # type: ignore

    @classmethod
    def poll(cls, context):
        return (context.active_object is not None and context.active_object.mode == 'OBJECT') 
    
    def execute(self, context):
        prefs =  get_keyops_prefs()
        pivot_behavior = prefs.maya_pivot_behavior
        show_gizmo = prefs.maya_pivot_show_gizmo

        global previuse_gizmo_translate_state

        if context.mode == 'OBJECT':
            if self.type == 'PivotPress':
                if not context.scene.tool_settings.use_transform_data_origin:
                    if bpy.context.space_data.show_gizmo_object_translate:
                        previuse_gizmo_translate_state = True
                    else:
                        previuse_gizmo_translate_state = False

                if pivot_behavior == 'TOGGLE':
                    if context.scene.tool_settings.use_transform_data_origin:
                        bpy.context.space_data.show_gizmo_object_translate = previuse_gizmo_translate_state

                    context.scene.tool_settings.use_transform_data_origin = not context.scene.tool_settings.use_transform_data_origin
                
                    if show_gizmo and context.scene.tool_settings.use_transform_data_origin:
                        bpy.context.space_data.show_gizmo_context = True
                        bpy.context.space_data.show_gizmo_object_translate = True
                    else:
                        bpy.context.space_data.show_gizmo_object_translate = previuse_gizmo_translate_state
                
                else:
                    context.scene.tool_settings.use_transform_data_origin = True
                    if show_gizmo and bpy.context.space_data.show_gizmo_object_translate == False:
                        bpy.context.space_data.show_gizmo_context = True
                        bpy.context.space_data.show_gizmo_object_translate = True
                    
            elif self.type == 'PivotRelease':
                if pivot_behavior == 'HOLD':
                    context.scene.tool_settings.use_transform_data_origin = False
                    if show_gizmo:
                        bpy.context.space_data.show_gizmo_object_translate = previuse_gizmo_translate_state

        # elif context.mode == 'EDIT_MESH':
        #     global current_active_tool

        #     if self.type == 'PivotPress':
        #         tools = bpy.context.workspace.tools
        #         current_tool = tools.from_space_view3d_mode(bpy.context.mode).idname
        #         if current_tool != 'builtin.cursor':
        #             current_active_tool = current_tool

        #         bpy.ops.wm.tool_set_by_id(name='builtin.cursor')

        #         context.area.tag_redraw()
        #         context.window_manager.show_3d_gizmo = True
        #         context.scene.tool_settings.transform_pivot_point = 'CURSOR'
        #         context.scene.transform_orientation_slots[0].type = 'CURSOR'

        #         # modal test
        #         # bpy.ops.transform.translate('INVOKE_DEFAULT', cursor_transform=True, orient_type='CURSOR', orient_matrix_type='CURSOR', constraint_axis=(False, False, False))
        #         # if current_active_tool:
        #         #     bpy.ops.wm.tool_set_by_id(name=current_active_tool)
        #         # context.window_manager.show_3d_gizmo = False
        #         # context.area.tag_redraw()


        #     elif self.type == 'PivotRelease':
        #         # reset tool to current_tool
        #         if current_active_tool:
        #             bpy.ops.wm.tool_set_by_id(name=current_active_tool)
        #         context.window_manager.show_3d_gizmo = False
        #         context.area.tag_redraw()
        #         # timer that resets the pivot after 0.5 seconds
        #         # bpy.app.timers.register(functools.partial(reset_pivot, context), first_interval=2)
        
        return {'FINISHED'}
        
    # need to temp turn of drawing tool! 

    # def register():
    #     bpy.utils.register_class(Gizmo3DGroup)
    #     bpy.utils.register_class(RotatePivotOperator)
    #     bpy.utils.register_class(RotatePivotOperator2)
    #     bpy.types.WindowManager.show_3d_gizmo = bpy.props.BoolProperty(
    #         name="Pivot Gizmo",
    #         description="Show 3D Cursor Gizmo",
    #         default=False
    #     )

    # def unregister():
    #     # bpy.utils.unregister_class(Gizmo3DGroup)
    #     # bpy.utils.unregister_class(RotatePivotOperator)
    #     # bpy.utils.unregister_class(RotatePivotOperator2)
    #     del bpy.types.WindowManager.show_3d_gizmo

class RotatePivotOperator2(bpy.types.Operator):
    bl_description = "Rotate Pivot"
    bl_idname = "keyops.rotate_pivot2"
    bl_label = "KeyOps: Rotate Pivot"
    bl_options = {'REGISTER', 'UNDO'}

    constraint_axis: bpy.props.StringProperty(default=""
    ) # type: ignore
    def execute(self, context):

        def press_r():
            axis = self.constraint_axis.upper()
            #press R key with ctypes
            ctypes.windll.user32.keybd_event(0x52, 0, 0, 0)
            ctypes.windll.user32.keybd_event(0x52, 0, 2, 0)

            # press axis key with ctypes
            if axis == 'X':
                ctypes.windll.user32.keybd_event(0x58, 0, 0, 0)
                ctypes.windll.user32.keybd_event(0x58, 0, 2, 0)
            elif axis == 'Y':
                ctypes.windll.user32.keybd_event(0x59, 0, 0, 0)
                ctypes.windll.user32.keybd_event(0x59, 0, 2, 0)
            elif axis == 'Z':
                ctypes.windll.user32.keybd_event(0x5A, 0, 0, 0)
                ctypes.windll.user32.keybd_event(0x5A, 0, 2, 0)
            else:
                return None
            
            return None  # Return None to stop the timer

        bpy.app.timers.register(press_r, first_interval=0.001)
        bpy.ops.transform.translate('INVOKE_DEFAULT', cursor_transform=True, orient_type='CURSOR', orient_matrix_type='CURSOR', constraint_axis=(False, False, False))
        return {'FINISHED'}

class RotatePivotOperator(bpy.types.Operator):
    bl_description = "Rotate Pivot"
    bl_idname = "keyops.rotate_pivot"
    bl_label = "KeyOps: Rotate Pivot"
    bl_options = {'REGISTER', 'UNDO'}

    axis: bpy.props.EnumProperty(
        name="Axis",
        description="Axis to rotate around",
        items=[
            ('X', "X", "Rotate around X-axis"),
            ('Y', "Y", "Rotate around Y-axis"),
            ('Z', "Z", "Rotate around Z-axis")
        ],
        default='Z'
    ) # type: ignore

    def __init__(self):
        self.start_mouse_x = 0
        self.start_rotation = mathutils.Matrix.Identity(3)

    def invoke(self, context, event):
        # Store initial mouse position and 3D cursor rotation
        self.start_mouse_x = event.mouse_x
        self.start_rotation = context.scene.cursor.rotation_euler.copy()

        context.window_manager.modal_handler_add(self)
        return {'RUNNING_MODAL'}

    def modal(self, context, event):
        if event.type == 'MOUSEMOVE':
            # Calculate the mouse movement delta
            delta_x = event.mouse_x - self.start_mouse_x

            # Check if shift is held for slower rotation
            scale_factor = 0.1 if event.shift else 0.5

            # Convert the delta to a rotation angle (scaled down for usability)
            rotation_angle = math.radians(delta_x * -scale_factor)

            # Apply rotation based on the selected axis
            new_rotation = self.start_rotation.copy()
            if self.axis == 'X':
                new_rotation.x += rotation_angle
            elif self.axis == 'Y':
                new_rotation.y += rotation_angle
            elif self.axis == 'Z':
                new_rotation.z += rotation_angle

            context.scene.cursor.rotation_euler = new_rotation

            return {'RUNNING_MODAL'}
        
        elif event.type in {'LEFTMOUSE', 'RET'}:
            # Confirm and exit
            return {'FINISHED'}

        elif event.type in {'RIGHTMOUSE', 'ESC'}:
            # Cancel and revert rotation
            context.scene.cursor.rotation_euler = self.start_rotation
            return {'CANCELLED'}
        
        # reset rotation on alt r 
        elif event.type == 'R' and event.value == 'PRESS' and event.alt:
            context.scene.cursor.rotation_euler = mathutils.Euler((0, 0, 0), 'XYZ')
            return {'CANCELLED'}

        return {'RUNNING_MODAL'}

class Gizmo3DGroup(bpy.types.GizmoGroup):
    bl_idname = "VIEW3D_GT_gizmo_group_3d"
    bl_label = "3D Cursor Gizmo"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'WINDOW'
    bl_options = {'3D', 'PERSISTENT'}

    @classmethod
    def poll(cls, context):
        return (
            context.area.type == 'VIEW_3D'
            and context.mode in {'OBJECT', 'EDIT_MESH'}
            and context.window_manager.show_3d_gizmo
        )

    def setup(self, context):
        gizmo_data = [
            ('x', 'GIZMO_GT_arrow_3d', (True, False, False)),
            ('y', 'GIZMO_GT_arrow_3d', (False, True, False)),
            ('z', 'GIZMO_GT_arrow_3d', (False, False, True)),
            ('dot', 'GIZMO_GT_move_3d', (False, False, False))
        ]

        self.r_gizmo = {}
        self.v_axes = {}

        for axis, gizmo_type, constraint_axis in gizmo_data:
            gizmo1 = self.gizmos.new(gizmo_type)
            gizmo1.use_tooltip = False
            gizmo1.use_draw_modal = False
            gizmo1.use_draw_hover = axis != 'dot'
            gizmo1.line_width = 2
            gizmo1.hide_select = False

            self.r_gizmo[f"{axis}_inv"] = gizmo1
            op = gizmo1.target_set_operator('transform.translate')
            op.constraint_axis = constraint_axis
            op.release_confirm = True
            op.cursor_transform = True
            op.orient_type = 'CURSOR'

            gizmo2 = self.gizmos.new(gizmo_type)
            gizmo2.use_tooltip = False
            gizmo2.color = (0, 0, 0)
            gizmo2.alpha = 1
            gizmo2.line_width = 2
            gizmo2.hide_select = True

            self.v_axes[axis] = gizmo2

        self.r_gizmo['dot_inv'].draw_options = {'FILL_SELECT', 'ALIGN_VIEW'}
        self.v_axes['dot'].draw_options = {'FILL_SELECT', 'ALIGN_VIEW'}

        # Add rotation gizmos for X, Y, Z
        self.rot_gizmos = {}
        rotation_colors = {
            'x': (1.0, 0.0, 0.0),
            'y': (0.0, 1.0, 0.0),
            'z': (0.0, 0.0, 1.0),
        }

        for axis in ['x', 'y', 'z']:
            gizmo = self.gizmos.new('GIZMO_GT_dial_3d')
            gizmo.use_tooltip = False
            gizmo.line_width = 1.0  
            gizmo.scale_basis = 0.4
            gizmo.color = rotation_colors[axis]
            gizmo.alpha = 0.75
            self.rot_gizmos[axis] = gizmo
            op = gizmo.target_set_operator('keyops.rotate_pivot2')
            op.constraint_axis = axis.upper()

    def refresh(self, context):
        cursor = context.scene.cursor

        colors = {
            'x': (1.0, 0.211766, 0.325486),
            'y': (0.541176, 0.85883, 0.0),
            'z': (0.172551, 0.560786, 1.0),
            'dot': (1.0, 1.0, 1.0),
        }

        dot_scale = 0.2
        arrow_size = {'scale': 1.0, 'length': 0.8, 'line_width': 2.0}
        dot_size = {'line_width': 1.65}
        rot_size = {'scale': 0.65, 'line_width': 1.2}  # Rotation gizmo size
        
        for axis in ['x', 'y', 'z', 'dot']:
            matrix = cursor.matrix
            if axis == 'x':
                matrix @= Matrix.Rotation(math.radians(90), 4, 'Y')
            elif axis == 'y':
                matrix @= Matrix.Rotation(math.radians(-90), 4, 'X')

            gizmo1 = self.r_gizmo[f"{axis}_inv"]
            gizmo2 = self.v_axes[axis]

            gizmo1.matrix_basis = matrix
            gizmo1.color = (1.0, 1.0, 1.0) if axis == 'dot' and gizmo1.is_highlight else (0.7, 0.7, 0.7)
            gizmo1.alpha = 0.75
            gizmo1.scale_basis = dot_scale if axis == 'dot' else arrow_size['scale']
            gizmo1.line_width = dot_size['line_width'] if axis == 'dot' else arrow_size['line_width']

            gizmo2.matrix_basis = matrix
            gizmo2.color = colors[axis]
            gizmo2.alpha = 1.0
            gizmo2.scale_basis = dot_scale if axis == 'dot' else arrow_size['scale']
            gizmo2.line_width = dot_size['line_width'] if axis == 'dot' else arrow_size['line_width']
            # gizmo2.length = arrow_size['length'] if axis != 'dot' else None

        # Update rotation gizmos
        for axis, gizmo in self.rot_gizmos.items():
            matrix = cursor.matrix
            if axis == 'x':
                matrix @= Matrix.Rotation(math.radians(90), 4, 'Y')
            elif axis == 'y':
                matrix @= Matrix.Rotation(math.radians(-90), 4, 'X')

            gizmo.matrix_basis = matrix
            gizmo.scale_basis = rot_size['scale']
            gizmo.line_width = rot_size['line_width']

    def draw_prepare(self, context):
        self.refresh(context)
